;*****************************************************************************
;  Batch file for reading dumped files.
;
;  Run-time inputs required:
;  1) nfile -- file name.
;  2) header_size -- number of lines in the header.
;  
;  v1 - 12/28/2006 - Chunhui Pan
;  v2 - 11/26/2007 - Jeff McIntire
;  v3 - 5/21/2007 - Jeff McIntire 
;     Added header exclusion.
;*****************************************************************************

PRO read_dmpd2, nfile,header_size,uaid,collect,scan,ham,apid,band,dnb_s,det,dsect,frame,offset,gain,dns

npar = n_params(0)
IF npar LT 1 THEN BEGIN
    retall
ENDIF

nlines=File_Lines(nfile)
IF nlines EQ 0 THEN retall

awa=''
uaid=fltarr(nlines)		; UAID.
collect=fltarr(nlines)		; Collect #.
scan=fltarr(nlines)		; Scan #.
ham=fltarr(nlines)		; HAM side.
apid=fltarr(nlines)		; APID.
band=strarr(nlines)		; Band name.
dnb_s=fltarr(nlines)
det=fltarr(nlines)		; Detector #.
dsect=fltarr(nlines)
frame=fltarr(nlines)		; Sample #.
offset=fltarr(nlines)		; Offset.
gain=fltarr(nlines)		; Gain.
dns=dblarr(nlines)		; dn.

openr,lun,nfile,/Get_Lun
	
; Remove header.
header=strarr(1)
IF header_size[0] EQ 0 THEN goto,skiph
FOR j=0, header_size[0]-1 DO BEGIN
	readf,lun,header
ENDFOR
skiph:

FOR ix=0L, nlines-header_size[0]-1 DO BEGIN
	readf,lun,awa
	a1=strsplit(awa,String(9B),/Extract)
	uaid(ix)=a1(0)
	collect(ix)=a1(1)
	scan(ix)=a1(2)
	ham(ix)=a1(3)
	apid(ix)=a1(4)
	band(ix)=a1(5)
	dnb_s(ix)=a1(6)
	det(ix)=a1(7)
	dsect(ix)=a1(8)
	frame(ix)=a1(9)
	offset(ix)=a1(10)
	gain(ix)=a1(11)
	dns(ix)=DOUBLE(a1(12))
ENDFOR
Free_Lun,lun

END
